# Rule State

## The two rule states

Every Rule (Decision Rule/Scripting Rules/Rule Flow) table has two control states: **`Published`** and **`Pending`**. The state can be set on every **version** of the rule separately.

Decision tables and scripting rules are in **`Published`** state when created, but Rule Flow are in **`Pending`** state as well as all newly created versions and all imported rules.

### Published state

Rule in **`Published`** state is ready for production and is available via [Solver API](/doc/v1/api/rule-solver-api.md).

#### Examples:

![](/files/-MPKdrkpUUvh87Aie-Yl)

![](/files/-MPKd5lcApj_sW70jHY7)

### Pending state

Some rules or versions of rules are not yet ready for production. For example, because the rule is still in development. Such a rule has a "Pending" status and it cannot be accessed using [Solver API](/doc/v1/api/rule-solver-api.md). When trying to solve such a rule, [Solver API](/doc/v1/api/rule-solver-api.md) returns the following HTTP request error:

```javascript
400 Bad Request
{
  "error": {
    "message": "Rule state is not published"
  }
}
```

{% hint style="success" %}
For the purpose of testing your rules and their versions that are not yet in production, you can use the **Debug** in [Test Bench](/doc/v1/other/test-bench.md) to solve the rule even if it is in the "Pending" state.
{% endhint %}

#### Example:

![Rule in pending state](/files/-MPKfGfqPDIneggWyon6)

### How to change the rule state

The state can be changed in rule detail by clicking on "State". The rule **must be saved** to apply the changes made on the state.

![](/files/-MPKdXQFGpwPflxKmsfA)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.decisionrules.io/doc/v1/other/rule-state.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
